/*
 * Copyright 2018 A-SIT Plus GmbH
 * AT-specific eIDAS Connector has been developed in a cooperation between EGIZ,
 * A-SIT Plus GmbH, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "License");
 * You may not use this work except in compliance with the License.
 * You may obtain a copy of the License at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
*/

package at.asitplus.eidas.specific.connector.controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import at.asitplus.eidas.specific.connector.MsEidasNodeConstants;
import at.gv.egiz.eaaf.core.exceptions.EaafException;
import at.gv.egiz.eaaf.modules.pvp2.idp.impl.AbstractPvp2XProtocol;
import at.gv.egiz.eaaf.modules.pvp2.idp.impl.PvpSProfilePendingRequest;

@Controller
public class Pvp2SProfileEndpoint extends AbstractPvp2XProtocol {

  public static final String NAME = Pvp2SProfileEndpoint.class.getName();
  public static final String PROTOCOL_ID = "pvp2-s";

  @RequestMapping(value = MsEidasNodeConstants.ENDPOINT_PVP_METADATA, method = { RequestMethod.POST,
      RequestMethod.GET })
  public void pvpMetadataRequest(HttpServletRequest req, HttpServletResponse resp) throws EaafException {
    super.pvpMetadataRequest(req, resp);

  }

  @RequestMapping(value = MsEidasNodeConstants.ENDPOINT_PVP_POST, method = { RequestMethod.POST })
  public void pvpIdpPostRequest(HttpServletRequest req, HttpServletResponse resp) throws EaafException {
    super.pvpIdpPostRequest(req, resp);

  }

  @RequestMapping(value = MsEidasNodeConstants.ENDPOINT_PVP_REDIRECT, method = { RequestMethod.GET })
  public void pvpIdpRedirecttRequest(HttpServletRequest req, HttpServletResponse resp) throws EaafException {
    super.pvpIdpRedirecttRequest(req, resp);

  }

  @Override
  public String getAuthProtocolIdentifier() {
    return PROTOCOL_ID;
  }

  @Override
  public String getName() {
    return NAME;
  }

  @Override
  protected boolean childPreProcess(HttpServletRequest arg0, HttpServletResponse arg1,
      PvpSProfilePendingRequest arg2)
      throws Throwable {
    return false;
  }

}
