/*
 * Copyright 2018 A-SIT Plus GmbH
 * AT-specific eIDAS Connector has been developed in a cooperation between EGIZ,
 * A-SIT Plus GmbH, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "License");
 * You may not use this work except in compliance with the License.
 * You may obtain a copy of the License at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
*/

package at.asitplus.eidas.specific.connector.mapper;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import at.gv.egiz.eaaf.core.api.data.EaafConstants;
import at.gv.egiz.eaaf.core.api.data.ILoALevelMapper;

@Service("LoALevelMapper")
public class LoALevelMapper implements ILoALevelMapper {
  private static final Logger log = LoggerFactory.getLogger(LoALevelMapper.class);

  @Override
  public String mapToSecClass(String loa) {
    log.info("Mapping to PVP SecClass is NOT supported");
    return null;
  }

  @Override
  public String mapToEidasLoa(String loa) {
    if (loa.startsWith(EaafConstants.EIDAS_LOA_PREFIX)) {
      return loa;
    } else {
      log.info("Can NOT map '" + loa + "' to eIDAS LoA");
    }

    return null;

  }

  @Override
  public String mapEidasQaaToStorkQaa(String eidasqaaLevel) {
    return null;
  }

}
