/*
 * Copyright 2018 A-SIT Plus GmbH
 * AT-specific eIDAS Connector has been developed in a cooperation between EGIZ,
 * A-SIT Plus GmbH, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "License");
 * You may not use this work except in compliance with the License.
 * You may obtain a copy of the License at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
*/

package at.asitplus.eidas.specific.modules.auth.eidas.v2.dao;

import java.text.SimpleDateFormat;

import org.joda.time.DateTime;

import at.gv.e_government.reference.namespace.persondata._20020228.PostalAddressType;

public class ErnbEidData {

  private String citizenCountryCode = null;

  // MDS
  private String pseudonym = null;
  private String givenName = null;
  private String familyName = null;
  private DateTime dateOfBirth = null;

  // additional attributes
  private String placeOfBirth = null;
  private String birthName = null;
  private PostalAddressType address = null;

  public String getCitizenCountryCode() {
    return citizenCountryCode;
  }

  public void setCitizenCountryCode(String citizenCountryCode) {
    this.citizenCountryCode = citizenCountryCode;
  }

  public String getPseudonym() {
    return pseudonym;
  }

  public void setPseudonym(String pseudonym) {
    this.pseudonym = pseudonym;
  }

  public String getGivenName() {
    return givenName;
  }

  public void setGivenName(String givenName) {
    this.givenName = givenName;
  }

  public String getFamilyName() {
    return familyName;
  }

  public void setFamilyName(String familyName) {
    this.familyName = familyName;
  }

  public DateTime getDateOfBirth() {
    return dateOfBirth;
  }

  public void setDateOfBirth(DateTime dateOfBirth) {
    this.dateOfBirth = dateOfBirth;
  }

  public String getPlaceOfBirth() {
    return placeOfBirth;
  }

  public void setPlaceOfBirth(String placeOfBirth) {
    this.placeOfBirth = placeOfBirth;
  }

  public String getBirthName() {
    return birthName;
  }

  public void setBirthName(String birthName) {
    this.birthName = birthName;
  }

  public PostalAddressType getAddress() {
    return address;
  }

  public void setAddress(PostalAddressType address) {
    this.address = address;
  }

  public String getFormatedDateOfBirth() {
    return new SimpleDateFormat("yyyy-MM-dd").format(dateOfBirth.toDate());
  }

}
