package at.asitplus.eidas.specific.modules.auth.eidas.v2.test.dummy;

import java.util.Collection;

import eu.eidas.auth.commons.attribute.AttributeDefinition;
import eu.eidas.auth.commons.light.ILightRequest;
import eu.eidas.auth.commons.light.ILightResponse;
import eu.eidas.auth.commons.tx.BinaryLightToken;
import eu.eidas.specificcommunication.BinaryLightTokenHelper;
import eu.eidas.specificcommunication.exception.SpecificCommunicationException;
import eu.eidas.specificcommunication.protocol.SpecificCommunicationService;

public class DummySpecificCommunicationService implements SpecificCommunicationService {

  private ILightRequest lightRequest;
  private ILightResponse lightResponse;

  @Override
  public BinaryLightToken putRequest(ILightRequest lightRequest) throws SpecificCommunicationException {
    this.lightRequest = lightRequest;
    return BinaryLightTokenHelper.createBinaryLightToken("Test", "TestSecret", "SHA-256");
  }

  @Override
  public ILightRequest getAndRemoveRequest(String tokenBase64, Collection<AttributeDefinition<?>> registry)
      throws SpecificCommunicationException {
    return lightRequest;
  }

  @Override
  public BinaryLightToken putResponse(ILightResponse lightResponse) throws SpecificCommunicationException {
    this.lightResponse = lightResponse;
    return BinaryLightTokenHelper.createBinaryLightToken("Test", "TestSecret", "SHA-256");
  }

  @Override
  public ILightResponse getAndRemoveResponse(String tokenBase64, Collection<AttributeDefinition<?>> registry)
      throws SpecificCommunicationException {
    return lightResponse;
  }

  public ILightRequest getiLightRequest() {
    return lightRequest;
  }

  public void setiLightRequest(ILightRequest lightReques) {
    this.lightRequest = lightReques;
  }

  public ILightResponse getiLightResponse() {
    return lightResponse;
  }

  public void setiLightResponse(ILightResponse lightResponse) {
    this.lightResponse = lightResponse;
  }

}
